| OpendTect 8.0

Loading...
Searching...
No Matches
Classes | Public Member Functions | Static Public Member Functions | Public Attributes | Protected Member Functions | Private Types | Private Member Functions | Private Attributes | List of all members
Pick::Set Class Reference
General

Set of picks with something in common. More...

`#include <pickset.h>`

Inheritance diagram for Pick::Set:
[legend]

## Classes
struct | Disp

## Public Member Functions
| Set (const char *nm=nullptr, bool ispolygon=false)
| Set (const Set &)
int | add (const Coord &, float z)
int | add (const Coord3 &)
int | add (const Location &)
void | addStartIdx (int locidx)
bool | append (const Pick::Set &)
void | appendWithUndo (const Pick::Location &)
void | bulkAppendWithUndo (const TypeSet< Pick::Location > &, const TypeSet< int > &indexes)
void | bulkRemoveWithUndo (const TypeSet< Pick::Location > &, const TypeSet< int > &indexes)
bool | fillDataPointSet (DataPointSet &) const
void | fillDisplayPars (IOPar &) const
void | fillPar (IOPar &) const
int | find (const TrcKey &) const
void | findStartIdxs ()
OD::GeomSystem | geomSystem () const
| pre-6.0.1 sets will return the survID of first loc
const Location & | get (int idx) const
void | getBoundingBox (TrcKeyZSampling &) const
void | getLocations (TypeSet< Coord3 > &, int setidx=0) const
void | getPolygon (ODPolygon< double > &, int idx=0) const
const Coord3 & | getPos (int idx) const
void | getStartStopIdx (int setidx, int &start, int &stop) const
OD::GeomSystem | getSurvID () const
float | getXYArea (int idx=0) const
| Only for closed polygons. Returns in (XYUnit)^2.
float | getZ (int idx) const
void | insert (int idx, const Location &)
void | insertWithUndo (int, const Pick::Location &)
bool | is2D () const
| default is 3D
bool | isEmpty () const
bool | isPolygon () const
bool | isReadOnly () const
bool | isSizeLargerThanThreshold () const
const TypeSet< Location > & | locations () const
void | moveWithUndo (int, const Pick::Location &, const Pick::Location &)
int | nearestLocation (const Coord &) const
int | nearestLocation (const Coord3 &, bool ignorez=false) const
int | nrSets () const
Set & | operator= (const Set &)
void | remove (int idx)
void | removeSingleWithUndo (int)
void | set (int idx, const Location &)
bool | setCapacity (int sz)
void | setDefaultDispPars (bool ispolygon)
void | setDip (int idx, float inldip, float crldip)
void | setDir (int idx, const Sphere &)
void | setEmpty ()
void | setKeyedText (int idx, const char *key, const char *txt)
void | setPos (int idx, const Coord &)
void | setPos (int idx, const Coord3 &)
void | setReadOnly (bool yn)
bool | setSize (int, const Coord3 &defval=Coord3::udf())
void | setStartIdx (int setidx, int locidx)
void | setZ (int idx, float z)
Set & | setZDomain (const ZDomain::Info &)
int | size () const
const TypeSet< int > & | startIndexs () const
bool | useDisplayPars (const IOPar &)
bool | usePar (const IOPar &)
bool | validIdx (int idx) const
bool | writeDisplayPars () const
const ZDomain::Info & | zDomain () const
bool | zInFeet () const
bool | zInMeter () const
bool | zIsTime () const
const UnitOfMeasure * | zUnit () const
Public Member Functions inherited from SharedObject
| SharedObject (const char *nm=nullptr)
Public Member Functions inherited from NamedCallBacker
| NamedCallBacker (const char *nm=nullptr)
| NamedCallBacker (const NamedCallBacker &)=delete
| ~NamedCallBacker ()
virtual Notifier< NamedCallBacker > & | objectToBeDeleted () const
NamedCallBacker & | operator= (const NamedCallBacker &)=delete
bool | operator== (const NamedCallBacker &oth) const
bool | operator== (const NamedObject &oth) const
Public Member Functions inherited from CallBacker
| CallBacker ()
| CallBacker (const CallBacker &)
virtual | ~CallBacker ()
bool | attachCB (const NotifierAccess &, const CallBack &, bool onlyifnew=false) const
bool | attachCB (const NotifierAccess *notif, const CallBack &cb, bool onlyifnew=false) const
void | detachAllNotifiers () const
| Call from the destructor of your inherited object.
void | detachCB (const NotifierAccess &, const CallBack &) const
void | detachCB (const NotifierAccess *notif, const CallBack &cb) const
virtual bool | isCapsule () const
bool | isNotifierAttached (const NotifierAccess *) const
| Only for debugging purposes, don't use.
CallBacker & | operator= (const CallBacker &)=delete
void | stopReceivingNotifications () const
virtual CallBacker * | trueCaller ()
Public Member Functions inherited from NamedObject
| NamedObject (const char *nm=nullptr)
| NamedObject (const NamedObject &oth)
virtual | ~NamedObject ()
virtual BufferString | getName () const
bool | getNameFromPar (const IOPar &)
const name_type & | name () const override
NamedObject & | operator= (const NamedObject &)
bool | operator== (const NamedObject &oth) const
virtual void | setName (const char *nm)
Public Member Functions inherited from ObjectWithName
virtual | ~ObjectWithName ()
bool | hasName (const char *nm) const
bool | hasName (const name_type &nm) const
void | putNameInPar (IOPar &) const
Public Member Functions inherited from RefCount::Referenced
void | addObserver (WeakPtrBase *obs)
| Not for normal use. May become private.
int | nrRefs () const
| Only for expert use.
void | ref () const
bool | refIfReffed () const
| Don't use in production, for debugging.
void | removeObserver (WeakPtrBase *obs)
| Not for normal use. May become private.
bool | tryRef () const
| Not for normal use. May become private.
void | unRef () const
void | unRefNoDelete () const

## Static Public Member Functions
static int | getSizeThreshold ()
static const char * | sKeyConnect ()
static const char * | sKeyFill ()
static const char * | sKeyFillColor ()
static const char * | sKeyMarkerType ()
static const char * | sKeyThresholdSize ()
static const char * | sKeyUseThreshold ()
Static Public Member Functions inherited from SharedObject
static Notifier< SharedObject > & | instanceCreated ()
Static Public Member Functions inherited from CallBacker
static void | createReceiverForCurrentThread ()
static void | removeReceiverForCurrentThread ()
Static Public Member Functions inherited from RefCount::Referenced
static bool | isSane (const Referenced *)

## Public Attributes
Disp | disp_
IOPar & | pars_

## Protected Member Functions
| ~Set ()
Protected Member Functions inherited from SharedObject
| ~SharedObject ()
Protected Member Functions inherited from NamedCallBacker
void | sendDelNotif () const
Protected Member Functions inherited from RefCount::Referenced
| Referenced ()
| Referenced (const Referenced &)
virtual | ~Referenced ()
Referenced & | operator= (const Referenced &)

## Private Types
enum | EventType { Insert , PolygonClose , Remove , Move }

## Private Member Functions
void | addBulkUndoEvent (EventType, const TypeSet< int > &, const TypeSet< Pick::Location > &)
void | addUndoEvent (EventType, int, const Pick::Location &)
void | refNotify () const override
void | unRefNotify () const override

## Private Attributes
TypeSet< Location > | locations_
bool | readonly_ = false
TypeSet< int > | startidxs_
const ZDomain::Info * | zdomaininfo_

## Additional Inherited Members
Public Types inherited from ObjectWithName
typedef OD::String | name_type
Protected Attributes inherited from NamedCallBacker
Threads::Atomic< bool > | delalreadytriggered_
Notifier< NamedCallBacker > | delnotif_
Protected Attributes inherited from NamedObject
BufferString | name_

## Detailed Description

Set of picks with something in common.

<>

## Member Enumeration Documentation

## ◆ EventType

enum Pick::Set::EventType
| private

Enumerator
Insert |
PolygonClose |
Remove |
Move |

## Constructor & Destructor Documentation

## ◆ Set() [1/2]

Pick::Set::Set | ( | const char * | nm = nullptr,
|  | bool | ispolygon = false )

## ◆ Set() [2/2]

Pick::Set::Set | ( | const Set & |  | ) |

## ◆ ~Set()

Pick::Set::~Set | ( |  | ) |
| protected

## Member Function Documentation

## ◆ add() [1/3]

int Pick::Set::add | ( | const Coord & | ,
|  | float | z )

## ◆ add() [2/3]

int Pick::Set::add | ( | const Coord3 & |  | ) |

## ◆ add() [3/3]

int Pick::Set::add | ( | const Location & |  | ) |

## ◆ addBulkUndoEvent()

void Pick::Set::addBulkUndoEvent | ( | EventType | ,
|  | const TypeSet< int > & | ,
|  | const TypeSet< Pick::Location > & | )
| private

## ◆ addStartIdx()

void Pick::Set::addStartIdx | ( | int | locidx | ) |

## ◆ addUndoEvent()

void Pick::Set::addUndoEvent | ( | EventType | ,
|  | int | ,
|  | const Pick::Location & | )
| private

## ◆ append()

bool Pick::Set::append | ( | const Pick::Set & |  | ) |

## ◆ appendWithUndo()

void Pick::Set::appendWithUndo | ( | const Pick::Location & |  | ) |

## ◆ bulkAppendWithUndo()

void Pick::Set::bulkAppendWithUndo | ( | const TypeSet< Pick::Location > & | ,
|  | const TypeSet< int > & | indexes )

## ◆ bulkRemoveWithUndo()

void Pick::Set::bulkRemoveWithUndo | ( | const TypeSet< Pick::Location > & | ,
|  | const TypeSet< int > & | indexes )

## ◆ fillDataPointSet()

bool Pick::Set::fillDataPointSet | ( | DataPointSet & |  | ) | const

## ◆ fillDisplayPars()

void Pick::Set::fillDisplayPars | ( | IOPar & |  | ) | const

## ◆ fillPar()

void Pick::Set::fillPar | ( | IOPar & |  | ) | const

## ◆ find()

int Pick::Set::find | ( | const TrcKey & |  | ) | const

## ◆ findStartIdxs()

void Pick::Set::findStartIdxs | ( |  | ) |

## ◆ geomSystem()

OD::GeomSystem Pick::Set::geomSystem | ( |  | ) | const

pre-6.0.1 sets will return the survID of first loc

## ◆ get()

const Location & Pick::Set::get | ( | int | idx | ) | const

## ◆ getBoundingBox()

void Pick::Set::getBoundingBox | ( | TrcKeyZSampling & |  | ) | const

## ◆ getLocations()

void Pick::Set::getLocations | ( | TypeSet< Coord3 > & | ,
|  | int | setidx = 0 ) const

## ◆ getPolygon()

void Pick::Set::getPolygon | ( | ODPolygon< double > & | ,
|  | int | idx = 0 ) const

## ◆ getPos()

const Coord3 & Pick::Set::getPos | ( | int | idx | ) | const

## ◆ getSizeThreshold()

static int Pick::Set::getSizeThreshold | ( |  | ) |
| static

## ◆ getStartStopIdx()

void Pick::Set::getStartStopIdx | ( | int | setidx,
|  | int & | start,
|  | int & | stop ) const

## ◆ getSurvID()

OD::GeomSystem Pick::Set::getSurvID | ( |  | ) | const
| inline

## ◆ getXYArea()

float Pick::Set::getXYArea | ( | int | idx = 0 | ) | const

Only for closed polygons. Returns in (XYUnit)^2.

## ◆ getZ()

float Pick::Set::getZ | ( | int | idx | ) | const

## ◆ insert()

void Pick::Set::insert | ( | int | idx,
|  | const Location & | )

## ◆ insertWithUndo()

void Pick::Set::insertWithUndo | ( | int | ,
|  | const Pick::Location & | )

## ◆ is2D()

bool Pick::Set::is2D | ( |  | ) | const

default is 3D

## ◆ isEmpty()

bool Pick::Set::isEmpty | ( |  | ) | const
| inline

## ◆ isPolygon()

bool Pick::Set::isPolygon | ( |  | ) | const

## ◆ isReadOnly()

bool Pick::Set::isReadOnly | ( |  | ) | const
| inline

## ◆ isSizeLargerThanThreshold()

bool Pick::Set::isSizeLargerThanThreshold | ( |  | ) | const

## ◆ locations()

const TypeSet< Location > & Pick::Set::locations | ( |  | ) | const
| inline

## ◆ moveWithUndo()

void Pick::Set::moveWithUndo | ( | int | ,
|  | const Pick::Location & | ,
|  | const Pick::Location & | )

## ◆ nearestLocation() [1/2]

int Pick::Set::nearestLocation | ( | const Coord & |  | ) | const

## ◆ nearestLocation() [2/2]

int Pick::Set::nearestLocation | ( | const Coord3 & | ,
|  | bool | ignorez = false ) const

## ◆ nrSets()

int Pick::Set::nrSets | ( |  | ) | const

## ◆ operator=()

Set & Pick::Set::operator= | ( | const Set & |  | ) |

## ◆ refNotify()

void Pick::Set::refNotify | ( |  | ) | const
| override private virtual

Reimplemented from RefCount::Referenced.

## ◆ remove()

void Pick::Set::remove | ( | int | idx | ) |

## ◆ removeSingleWithUndo()

void Pick::Set::removeSingleWithUndo | ( | int |  | ) |

## ◆ set()

void Pick::Set::set | ( | int | idx,
|  | const Location & | )

## ◆ setCapacity()

bool Pick::Set::setCapacity | ( | int | sz | ) |

## ◆ setDefaultDispPars()

void Pick::Set::setDefaultDispPars | ( | bool | ispolygon | ) |

## ◆ setDip()

void Pick::Set::setDip | ( | int | idx,
|  | float | inldip,
|  | float | crldip )

## ◆ setDir()

void Pick::Set::setDir | ( | int | idx,
|  | const Sphere & | )

## ◆ setEmpty()

void Pick::Set::setEmpty | ( |  | ) |

## ◆ setKeyedText()

void Pick::Set::setKeyedText | ( | int | idx,
|  | const char * | key,
|  | const char * | txt )

## ◆ setPos() [1/2]

void Pick::Set::setPos | ( | int | idx,
|  | const Coord & | )

## ◆ setPos() [2/2]

void Pick::Set::setPos | ( | int | idx,
|  | const Coord3 & | )

## ◆ setReadOnly()

void Pick::Set::setReadOnly | ( | bool | yn | ) |
| inline

## ◆ setSize()

bool Pick::Set::setSize | ( | int | ,
|  | const Coord3 & | defval = Coord3::udf() )

## ◆ setStartIdx()

void Pick::Set::setStartIdx | ( | int | setidx,
|  | int | locidx )

## ◆ setZ()

void Pick::Set::setZ | ( | int | idx,
|  | float | z )

## ◆ setZDomain()

Set & Pick::Set::setZDomain | ( | const ZDomain::Info & |  | ) |

## ◆ size()

int Pick::Set::size | ( |  | ) | const
| inline

## ◆ sKeyConnect()

static const char * Pick::Set::sKeyConnect | ( |  | ) |
| inline static

## ◆ sKeyFill()

static const char * Pick::Set::sKeyFill | ( |  | ) |
| inline static

## ◆ sKeyFillColor()

static const char * Pick::Set::sKeyFillColor | ( |  | ) |
| inline static

## ◆ sKeyMarkerType()

static const char * Pick::Set::sKeyMarkerType | ( |  | ) |
| inline static

## ◆ sKeyThresholdSize()

static const char * Pick::Set::sKeyThresholdSize | ( |  | ) |
| inline static

## ◆ sKeyUseThreshold()

static const char * Pick::Set::sKeyUseThreshold | ( |  | ) |
| inline static

## ◆ startIndexs()

const TypeSet< int > & Pick::Set::startIndexs | ( |  | ) | const
| inline

## ◆ unRefNotify()

void Pick::Set::unRefNotify | ( |  | ) | const
| override private virtual

Reimplemented from RefCount::Referenced.

## ◆ useDisplayPars()

bool Pick::Set::useDisplayPars | ( | const IOPar & |  | ) |

## ◆ usePar()

bool Pick::Set::usePar | ( | const IOPar & |  | ) |

## ◆ validIdx()

bool Pick::Set::validIdx | ( | int | idx | ) | const

## ◆ writeDisplayPars()

bool Pick::Set::writeDisplayPars | ( |  | ) | const

## ◆ zDomain()

const ZDomain::Info & Pick::Set::zDomain | ( |  | ) | const

## ◆ zInFeet()

bool Pick::Set::zInFeet | ( |  | ) | const

## ◆ zInMeter()

bool Pick::Set::zInMeter | ( |  | ) | const

## ◆ zIsTime()

bool Pick::Set::zIsTime | ( |  | ) | const

## ◆ zUnit()

const UnitOfMeasure * Pick::Set::zUnit | ( |  | ) | const

## Member Data Documentation

## ◆ disp_

Disp Pick::Set::disp_

## ◆ locations_

TypeSet<Location> Pick::Set::locations_
| private

## ◆ pars_

IOPar& Pick::Set::pars_

## ◆ readonly_

bool Pick::Set::readonly_ = false
| private

## ◆ startidxs_

TypeSet<int> Pick::Set::startidxs_
| private

## ◆ zdomaininfo_

const ZDomain::Info* Pick::Set::zdomaininfo_
| private

Generated at
for the OpendTect seismic interpretation project. Copyright (C): dGB Beheer B.V. 1995-2025